asner.h File Reference
`#include "asnper.h"`
`#include "asnber.h"`
`#include "asnxer.h"`

Go to the source code of this file.

## Classes

class | PASN_Object
| Base class for ASN encoding/decoding. More...
class | PASN_ConstrainedObject
| Base class for constrained ASN encoding/decoding. More...
class | PASN_Null
| Class for ASN Null type. More...
class | PASN_Boolean
| Class for ASN Boolean type. More...
class | PASN_Integer
| Class for ASN Integer type. More...
struct | PASN_Names
class | PASN_Enumeration
| Class for ASN Enumerated type. More...
class | PASN_Real
| Class for ASN floating point type. More...
class | PASN_ObjectId
| Class for ASN Object Identifier type. More...
class | PASN_BitString
| Class for ASN Bit String type. More...
class | PASN_OctetString
| Class for ASN Octet String type. More...
class | PASN_ConstrainedString
| Base class for ASN String types. More...
class | PASN_BMPString
| Class for ASN BMP (16 bit) String type. More...
class | PASN_GeneralisedTime
class | PASN_UniversalTime
class | PASN_Choice
| Class for ASN Choice type. More...
class | PASN_Sequence
| Class for ASN Sequence type. More...
class | PASN_Set
| Class for ASN Set type. More...
class | PASN_Array
| Class for ASN Array type. More...
class | PASN_Stream
| Base class for ASN decoder/encoder stream. More...

## Macros

#define | P_INCLUDE_PER
#define | P_INCLUDE_BER
#define | P_INCLUDE_XER
#define | DECLARE_STRING_CLASS(name)

## Functions

| DECLARE_STRING_CLASS (Numeric)
| DECLARE_STRING_CLASS (Printable)
| DECLARE_STRING_CLASS (Visible)
| DECLARE_STRING_CLASS (IA5)
| DECLARE_STRING_CLASS (General)
| PARRAY (PASN_ObjectArray, PASN_Object)

## Macro Definition Documentation

#define DECLARE_STRING_CLASS | ( |  | name | ) |

Value:
class PASN_##name##String : public PASN_ConstrainedString { \
PCLASSINFO(PASN_##name##String, PASN_ConstrainedString); \
public: \
PASN_##name##String(const char * str = NULL); \
PASN_##name##String(unsigned tag, TagClass tagClass); \
PASN_##name##String & operator=(const char * str); \
PASN_##name##String & operator=(const PString & str); \
virtual PObject * Clone() const; \
virtual PString GetTypeAsString() const; \
}
PCLASSINFO
#define PCLASSINFO(cls, par)
Declare all the standard PTLib class information.
Definition: object.h:1049
PASN_Object::GetTypeAsString
virtual PString GetTypeAsString() const =0
Return a string giving the type of the object.
PASN_ConstrainedString
Base class for ASN String types.
Definition: asner.h:510
PString
The character string class.
Definition: pstring.h:108
PASN_ConstrainedString::operator=
PASN_ConstrainedString & operator=(const char *str)
PObject::Clone
virtual PObject * Clone() const
Create a copy of the class on the heap.
PObject
Ultimate parent class for all objects in the class library.
Definition: object.h:1118

#define P_INCLUDE_BER

#define P_INCLUDE_PER

#define P_INCLUDE_XER

## Function Documentation

DECLARE_STRING_CLASS | ( | Numeric |  | ) |

DECLARE_STRING_CLASS | ( | Printable |  | ) |

DECLARE_STRING_CLASS | ( | Visible |  | ) |

DECLARE_STRING_CLASS | ( | IA5 |  | ) |

DECLARE_STRING_CLASS | ( | General |  | ) |

PARRAY | ( | PASN_ObjectArray | ,
|  | PASN_Object |
| ) |  |